=== modified file 'Makefile'
--- Makefile	2008-07-22 01:59:47 +0000
+++ Makefile	2007-10-20 21:38:25 +0000
@@ -1,28 +1,7 @@
-WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs -Wswitch-default -Wswitch-enum -Wunused-parameter -Wstrict-aliasing=2 -Wextra -Wfloat-equal -Wundef -Wshadow -Wunsafe-loop-optimizations -Wpointer-arith -Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wstrict-prototypes -Wold-style-definition -Wpacked -Wnested-externs -Wunreachable-code -Winline -Wvolatile-register-var 
-DEBUG=-ggdb3
-#COVERAGE=--coverage
-OPTIMIZE=-Os
-LANGUAGE=-std=gnu99
-
-# Do not change these two
-CFLAGS=$(WARN) $(COVERAGE) $(DEBUG) $(OPTIMIZE) $(LANGUAGE)
-LDFLAGS=$(COVERAGE)
-
-PROGS=plugbasedclient plugins.d/mandosclient plugins.d/passprompt
-
-objects=$(shell for p in $(PROGS); do echo $${p}.o; done)
-
-all: $(PROGS)
-
-plugbasedclient: plugbasedclient.o
-	$(LINK.o) -lgnutls $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-plugins.d/mandosclient: plugins.d/mandosclient.o
-	$(LINK.o) -lgnutls -lavahi-core -lgpgme $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-plugins.d/passprompt: plugins.d/passprompt.o
-	$(LINK.o) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-.PHONY : clean
+CXXFLAGS=-Wall -g
+LDFLAGS=-lgnutls
+
+all: client server
+
 clean:
-	-rm -f $(PROGS) $(objects) core
+	rm -f server client

=== removed file 'TODO'
--- TODO	2008-07-22 06:23:29 +0000
+++ TODO	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-[Mandos client]
-configuration for OpenPGP key
-header files/symbols tally
-check exit codes of all system calls
-IPv4 support
-
-[Pluginbasedclient]
-disable certain plugins
-header files/symbols tally
-check exit codes of all system calls
-change uid to nobody:nogroup
-	other drop privs stuff?
-
-[Server]
-config file for:
-	TXT record
-run-time communication with server
-
-[Mandos-tools/utilities]
-	List clients
-	Enable client
-	Disable client
-
-[Installer]
-...

=== added file 'bad-ca.pem'
--- bad-ca.pem	1970-01-01 00:00:00 +0000
+++ bad-ca.pem	2007-10-20 21:38:25 +0000
@@ -0,0 +1,40 @@
+-----BEGIN CERTIFICATE-----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+-----END CERTIFICATE-----

=== added file 'bad-cert.pem'
--- bad-cert.pem	1970-01-01 00:00:00 +0000
+++ bad-cert.pem	2007-10-20 21:38:25 +0000
@@ -0,0 +1,40 @@
+-----BEGIN CERTIFICATE-----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+-----END CERTIFICATE-----

=== added file 'bad-client-cert.pem'
--- bad-client-cert.pem	1970-01-01 00:00:00 +0000
+++ bad-client-cert.pem	2007-10-20 21:38:25 +0000
@@ -0,0 +1,40 @@
+-----BEGIN CERTIFICATE-----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+-----END CERTIFICATE-----

=== added file 'bad-client-key.pem'
--- bad-client-key.pem	1970-01-01 00:00:00 +0000
+++ bad-client-key.pem	2007-10-20 21:38:25 +0000
@@ -0,0 +1,51 @@
+-----BEGIN RSA PRIVATE KEY-----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=
+-----END RSA PRIVATE KEY-----

=== added file 'bad-crl.pem'
--- bad-crl.pem	1970-01-01 00:00:00 +0000
+++ bad-crl.pem	2007-10-20 21:38:25 +0000
@@ -0,0 +1,18 @@
+-----BEGIN X509 CRL-----
+MIIC1jCBvzANBgkqhkiG9w0BAQUFADCBjzELMAkGA1UEBhMCU0UxCzAJBgNVBAgT
+AkJMMRMwEQYDVQQHEwpLYXJsc2tyb25hMRUwEwYDVQQKEwxFdmlsIG1vbmtleXMx
+FDASBgNVBAsTC0V2aWwgd2UgYXJlMRMwEQYDVQQDEwppbnZhbGlkIENBMRwwGgYJ
+KoZIhvcNAQkBFg1ldmlsQGNlcnQuYmFkFw0wNzEwMTYxNDQxMTVaFw0wNzExMTUx
+NDQxMTVaMA0GCSqGSIb3DQEBBQUAA4ICAQCfNVz+uVzX2TaHb3YtAzVFrrjysuL/
+ltA2DAv4cpQSAYi6Gt5xDqcXE8ZonEA26taHYpXYnStnVsrrbK44sGFuvJc/y0jM
+AdA3Ook/ECTPmnJMU3jUbtK6dqFmF0425dDVPAdVqxlB2+wlA+tk/RHSfKMVi44X
+VCLPReQFpHUqMBdpqdfmxmtV4QXDgYAE5ramDiC0Eh9IZ1yEIKrFPx6VDUqph+uh
+uM3lusqW3afqaNPLWNf2+hJoeHAYd+b0Gd/W9epONJ2hI8jdo3QrdGHgOxlKRyJa
+3U4DDzi5rOy1eivxLo+OIzaxrff9Sw2yj0SvR7U9Tpkd3zIFBFxGujgNpA3g4NrK
+xGk1cQtx96siwkt6hvfnsPY5HjtUedOxOlVs2Rji9fxFAu7t5q10HHIHgHpTTSaU
+8GUmN8uiibndrrKEask6L0O48wg5fnjm7W1oOJG30z2N0zKV+HMSv146MoBUZFrK
+xSDjHP5qjL6H3GCZPIIvNqEFbHeOafWcqQAsusvxiMgM73ZwBs68hZDvQ1VcYKAL
+bsOwbzo/T3jh1shtpR2xL0pdTg+olqvgPlhLB07G4rCucVvrZnuw9YrtjBOEbIeH
+w7Lgq2CmpEK5tH+Zv8wt+k6rkdafaGe7G+fN48ZXfJ2dHIH37ZmIjC6t0UjybEmy
+e0R0/SpWZspsSQ==
+-----END X509 CRL-----

=== added file 'bad-key.pem'
--- bad-key.pem	1970-01-01 00:00:00 +0000
+++ bad-key.pem	2007-10-20 21:38:25 +0000
@@ -0,0 +1,51 @@
+-----BEGIN RSA PRIVATE KEY-----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=
+-----END RSA PRIVATE KEY-----

=== added file 'client.cpp'
--- client.cpp	1970-01-01 00:00:00 +0000
+++ client.cpp	2007-10-20 21:38:25 +0000
@@ -0,0 +1,149 @@
+extern "C" {
+#include <sys/types.h>		// getaddrinfo, gai_strerror, socket, inet_pton
+				// connect
+#include <sys/socket.h>		// getaddrinfo, gai_strerror, socket, inet_pton
+				// connect
+#include <unistd.h>		// close
+#include <netdb.h>		// getaddrinfo, gai_strerror
+#include <arpa/inet.h>		// inet_pton
+#include <sys/select.h> 	// select
+#include <gnutls/gnutls.h>
+}
+
+#include <cstdio>		// fprintf
+#include <cerrno>		// perror
+#include <cstring> 		// memset
+
+#define SOCKET_ERR(err,s) if(err<0) {perror(s);return(1);}
+#define PORT 49001
+#define CERTFILE "client-cert.pem"
+#define KEYFILE "client-key.pem"
+#define CAFILE "ca.pem"
+
+gnutls_certificate_credentials_t x509_cred;
+
+gnutls_session_t
+initgnutls(){
+  gnutls_session_t session;
+
+  gnutls_global_init ();
+
+  /* X509 stuff */
+  gnutls_certificate_allocate_credentials (&x509_cred);
+  gnutls_certificate_set_x509_trust_file (x509_cred, CAFILE, GNUTLS_X509_FMT_PEM);
+  gnutls_certificate_set_x509_key_file (x509_cred, CERTFILE, KEYFILE,
+					GNUTLS_X509_FMT_PEM);
+
+  //Gnutls stuff
+  gnutls_init (&session, GNUTLS_CLIENT);
+  gnutls_set_default_priority (session);
+  gnutls_credentials_set (session, GNUTLS_CRD_CERTIFICATE, x509_cred);
+  return session;
+}
+
+
+int main (){
+  int sd, ret;
+  char buffer[512];
+  struct sockaddr_in6 to;
+  struct sockaddr_in6 from;
+  gnutls_session_t session;
+  fd_set rfds_orig;
+  struct timeval timeout;
+
+  session = initgnutls ();
+
+  sd = socket(PF_INET6, SOCK_DGRAM, 0);
+  SOCKET_ERR(sd,"socket");
+ 
+  {
+    int flag = 1;
+    ret = setsockopt(sd, SOL_SOCKET, SO_BROADCAST, & flag, sizeof(flag));
+    SOCKET_ERR(ret,"setsockopt broadcast");
+  }
+
+  setsockopt(sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
+  SOCKET_ERR(ret,"setsockopt bindtodevice");
+
+  memset (&to, '\0', sizeof (to));
+  to.sin6_family = AF_INET6;
+  ret = inet_pton(AF_INET6, "ff02::1" , &to.sin6_addr);
+  SOCKET_ERR(ret,"setsockopt bindtodevice");
+  to.sin6_port = htons (PORT);	// Server Port number
+
+  FD_ZERO(&rfds_orig);
+  FD_SET(sd, &rfds_orig);
+
+  timeout.tv_sec = 10;
+  timeout.tv_usec = 0;
+
+
+  for(;;){
+    sendto(sd, "Marco", 5, 0, reinterpret_cast<const sockaddr*>(&to), sizeof(to));
+
+    fd_set rfds = rfds_orig;
+
+    ret = select(sd+1, &rfds, 0, 0, & timeout);
+    SOCKET_ERR(sd,"select");
+
+    if (ret){
+      socklen_t from_len = sizeof(from);
+      ret = recvfrom(sd,buffer,512,0, reinterpret_cast<sockaddr *>(& from),
+		     & from_len);
+      SOCKET_ERR(ret,"recv");
+
+      if (strncmp(buffer,"Polo", 4) == 0){
+	break;
+      }
+    }
+  }
+
+  write(1,buffer,ret);
+  write(1,"\n",1);
+
+  //shutdown procedure
+  close(sd);
+
+  sleep(1);
+
+  sd = socket(PF_INET6, SOCK_STREAM, 0);
+  SOCKET_ERR(sd,"socket");
+
+  setsockopt(sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
+  SOCKET_ERR(ret,"setsockopt bindtodevice");
+
+  memset(&to,0,sizeof(to));
+  to.sin6_family = from.sin6_family;
+  to.sin6_port   = from.sin6_port;
+  to.sin6_addr   = from.sin6_addr;
+  to.sin6_scope_id   = from.sin6_scope_id;
+
+  ret = connect(sd,reinterpret_cast<struct sockaddr *>(&to),sizeof(to));
+  SOCKET_ERR(ret,"connect");
+
+  gnutls_transport_set_ptr (session, reinterpret_cast<gnutls_transport_ptr_t> (sd));
+
+  ret = gnutls_handshake (session);
+
+  if (ret < 0)
+    {
+      fprintf (stderr, "*** Handshake failed\n");
+      gnutls_perror (ret);
+      return 1;
+    }
+  printf ("- Handshake was completed\n");
+
+  //message to be seent
+  gnutls_record_send (session, "The secret message is \"squeamish ossifrage\"\n", 44);
+
+  //shutdown procedure
+  gnutls_bye (session, GNUTLS_SHUT_RDWR);
+  close(sd);
+  gnutls_deinit (session);
+  gnutls_certificate_free_credentials (x509_cred);
+  gnutls_global_deinit ();
+
+  close(sd);
+
+  return 0;
+}

=== removed file 'mandos-clients.conf'
--- mandos-clients.conf	2008-07-22 06:23:29 +0000
+++ mandos-clients.conf	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-[DEFAULT]
-timeout = 1h
-interval = 5m
-checker = fping -q -- %%(fqdn)s
-
-# Example
-[foo]
-fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
-secret = Base+64+encoded+OpenPGP+encrypted+data/=
-# secfile = /etc/mandos/foo-secret.txt.asc
-fqdn = foo.example.org
-checker = fping -q -- %%(fqdn)s
-timeout = 10m
-
-[braxen_client]
-fingerprint =  7788 2722 5BA7 DE53 9C5A  7CFA 59CF F7CD BD9A 5920
-secret =
-        hQIOA6QdEjBs2L/HEAf/TCyrDe5Xnm9esa+Pb/vWF9CUqfn4srzVgSu234REJMVv
-        7lBSrPE2132Lmd2gqF1HeLKDJRSVxJpt6xoWOChGHg+TMyXDxK+NXl89vGvdU1Xf
-        hKkVm9MDLOgT5ECDPysDGHFPDhqHOSu3Kaw2DWMV/iH9vz3Z20erVNbdcvyBnuoj
-        coWO/6yfB5EQO0BXp7kcyy00USA3CjD5FGZdoQGITb8A/ar0tVA5crSQmaSotm6K
-        mNLhrFnZ5BxX+TiE+eTUTqSloWRY6VAvqWQHC7OASxK5E6RXPBuFH5IohUA2Qbk5
-        AHt99pYvsIPX88j2rWauOokoiKZot/9leJ8VxO5l3wf/U64IH8bkPIoWmWZfd/nq
-        h4uwGNbCgKMyT+AnvH7kMJ3i7DivfWl2mKLV0PyPHUNva0VQxX6yYjcOhj1R6fCr
-        /at8/NSLe2OhLchzdC+Ls9h+kvJXgF8Sisv+Wk/1RadPLFmraRlqvJwt6Ww21Lpi
-        XqXHV2mIgqWnR98YgSvUi3TJHrUQiNc9YyBzuRo0AjgG2C9qiE3FM+Y28+iQ/sR3
-        +bFszYuZKVTObqiIslwXu7imO0cvvFRgJF/6u3HNFQ4LUTGhiM3FQmC6NNlF3/vJ
-        M2hwRDMcJqDd54Twx90Wh+tYz0z7QMsK4ANXWHHWHR0JchnLWmenzbtW5MHdW9AY
-        sNJZAQSOpirE4Xi31CSlWAi9KV+cUCmWF5zOFy1x23P6PjdaRm4T2zw4dxS5NswX
-        WU0sVEXxjs6PYxuIiCTL7vdpx8QjBkrPWDrAbcMyBr2OQlnHIvPzEArRQLo=
-        =iHhv
-fqdn = localhost
-interval = 5m

=== removed file 'plugbasedclient.c'
--- plugbasedclient.c	2008-07-22 05:26:44 +0000
+++ plugbasedclient.c	1970-01-01 00:00:00 +0000
@@ -1,351 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Mandos plugin runner - Run Mandos plugins
- *
- * Copyright © 2007-2008 Teddy Hogeborn and Björn Påhlsson.
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _FORTIFY_SOURCE 2
-
-#include <stdio.h>	/* popen, fileno */
-#include <iso646.h>	/* and, or, not */
-#include <sys/types.h>	/* DIR, opendir, stat, struct stat, waitpid,
-			   WIFEXITED, WEXITSTATUS, wait */
-#include <sys/wait.h>	/* wait */
-#include <dirent.h>	/* DIR, opendir */
-#include <sys/stat.h>	/* stat, struct stat */
-#include <unistd.h>	/* stat, struct stat, chdir */
-#include <stdlib.h>	/* EXIT_FAILURE */
-#include <sys/select.h>	/* fd_set, select, FD_ZERO, FD_SET,
-			   FD_ISSET */
-#include <string.h>	/* strlen, strcpy, strcat */
-#include <stdbool.h>	/* true */
-#include <sys/wait.h>	/* waitpid, WIFEXITED, WEXITSTATUS */
-#include <errno.h>	/* errno */
-#include <argp.h>	/* argp */
-
-struct process;
-
-typedef struct process{
-  pid_t pid;
-  int fd;
-  char *buffer;
-  size_t buffer_size;
-  size_t buffer_length;
-  struct process *next;
-} process;
-
-typedef struct plugin{
-  char *name; 		/* can be "global" and any plugin name */
-  char **argv;
-  int argc;
-  struct plugin *next;
-} plugin;
-
-plugin *getplugin(char *name, plugin **plugin_list){
-  for (plugin *p = *plugin_list; p != NULL; p = p->next){
-    if ((p->name == name)
-	or (p->name and name and (strcmp(p->name, name) == 0))){
-      return p;
-    }
-  }
-  /* Create a new plugin */
-  plugin *new_plugin = malloc(sizeof(plugin));
-  if (new_plugin == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  new_plugin->name = name;
-  new_plugin->argv = malloc(sizeof(char *) * 2);
-  if (new_plugin->argv == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  new_plugin->argv[0] = name;
-  new_plugin->argv[1] = NULL;
-  new_plugin->argc = 1;
-  /* Append the new plugin to the list */
-  new_plugin->next = *plugin_list;
-  *plugin_list = new_plugin;
-  return new_plugin;
-}
-
-void addarguments(plugin *p, char *arg){
-  p->argv[p->argc] = arg;
-  p->argv = realloc(p->argv, sizeof(char *) * (size_t)(p->argc + 2));
-  if (p->argv == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  p->argc++;
-  p->argv[p->argc] = NULL;
-}
-	
-#define BUFFER_SIZE 256
-
-const char *argp_program_version =
-  "plugbasedclient 0.9";
-const char *argp_program_bug_address =
-  "<mandos@fukt.bsnet.se>";
-static char doc[] =
-  "Mandos plugin runner -- Run Mandos plugins";
-/* A description of the arguments we accept. */
-static char args_doc[] = "";
-
-int main(int argc, char *argv[]){
-  char plugindir[] = "plugins.d";
-  size_t d_name_len, plugindir_len = sizeof(plugindir)-1;
-  DIR *dir;
-  struct dirent *dirst;
-  struct stat st;
-  fd_set rfds_orig;
-  int ret, maxfd = 0;
-  process *process_list = NULL;
-  
-  /* The options we understand. */
-  struct argp_option options[] = {
-    { .name = "global-options", .key = 'g',
-      .arg = "option[,option[,...]]", .flags = 0,
-      .doc = "Options effecting all plugins" },
-    { .name = "options-for", .key = 'o',
-      .arg = "plugin:option[,option[,...]]", .flags = 0,
-      .doc = "Options effecting only specified plugins" },
-    { .name = NULL }
-  };
-  
-  error_t parse_opt (int key, char *arg, struct argp_state *state) {
-       /* Get the INPUT argument from `argp_parse', which we
-          know is a pointer to our arguments structure. */
-    plugin **plugins = state->input;
-    switch (key) {
-    case 'g':
-      if (arg != NULL){
-	char *p = strtok(arg, ",");
-	do{
-	  addarguments(getplugin(NULL, plugins), p);
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case 'o':
-      if (arg != NULL){
-	char *name = strtok(arg, ":");
-	char *p = strtok(NULL, ":");
-	p = strtok(p, ",");
-	do{
-	  addarguments(getplugin(name, plugins), p);
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case ARGP_KEY_ARG:
-      argp_usage (state);
-      break;
-    case ARGP_KEY_END:
-      break;
-    default:
-      return ARGP_ERR_UNKNOWN;
-    }
-    return 0;
-  }
-
-  plugin *plugin_list = NULL;
-  
-  struct argp argp = { .options = options, .parser = parse_opt,
-		       .args_doc = args_doc, .doc = doc };
-
-  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);
-
-/*   for(plugin *p = plugin_list; p != NULL; p=p->next){ */
-/*     fprintf(stderr, "Plugin: %s has %d arguments\n", p->name ? p->name : "Global", p->argc); */
-/*     for(char **a = p->argv + 1; *a != NULL; a++){ */
-/*       fprintf(stderr, "\tArg: %s\n", *a); */
-/*     } */
-/*   } */
-  
-/*   return 0; */
-  
-  dir = opendir(plugindir);
-  
-  if(dir == NULL){
-    fprintf(stderr, "Can not open directory\n");
-    return EXIT_FAILURE;
-  }
-  
-  FD_ZERO(&rfds_orig);
-  
-  while(true){
-    dirst = readdir(dir);
-    
-    // All directory entries have been processed
-    if(dirst == NULL){
-      break;
-    }
-    
-    d_name_len = strlen(dirst->d_name);
-    
-    // Ignore dotfiles and backup files
-    if (dirst->d_name[0] == '.'
-	or dirst->d_name[d_name_len - 1] == '~'){
-      continue;
-    }
-
-    char *filename = malloc(d_name_len + plugindir_len + 2);
-    strcpy(filename, plugindir);
-    strcat(filename, "/");
-    strcat(filename, dirst->d_name);    
-
-    stat(filename, &st);
-
-    if (S_ISREG(st.st_mode) and (access(filename, X_OK) == 0)){
-      // Starting a new process to be watched
-      process *new_process = malloc(sizeof(process));
-      int pipefd[2];
-      ret = pipe(pipefd);
-      if (ret == -1){
-	perror(argv[0]);
-	goto end;
-      }
-      new_process->pid = fork();
-      if(new_process->pid == 0){
-	/* this is the child process */
-	closedir(dir);
-	close(pipefd[0]);	/* close unused read end of pipe */
-	dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
-	char *basename;
-	basename = strrchr(filename, '/');
-	if (basename == NULL){
-	  basename = filename;
-	} else {
-	  basename++;
-	}
-	plugin *p = getplugin(basename, &plugin_list);
-
-	plugin *g = getplugin(NULL, &plugin_list);
-	for(char **a = g->argv + 1; *a != NULL; a++){
-	  addarguments(p, *a);
-	}
-	if(execv(filename, p->argv) < 0){
-	  perror(argv[0]);
-	  close(pipefd[1]);
-	  exit(EXIT_FAILURE);
-	}
-	/* no return */
-      }
-      close(pipefd[1]);		/* close unused write end of pipe */
-      new_process->fd = pipefd[0];
-      new_process->buffer = malloc(BUFFER_SIZE);
-      if (new_process->buffer == NULL){
-	perror(argv[0]);
-	goto end;
-      }
-      new_process->buffer_size = BUFFER_SIZE;
-      new_process->buffer_length = 0;
-      FD_SET(new_process->fd, &rfds_orig);
-      
-      if (maxfd < new_process->fd){
-	maxfd = new_process->fd;
-      }
-      
-      //List handling
-      new_process->next = process_list;
-      process_list = new_process;
-    }
-  }
-  
-  closedir(dir);
-  
-  if (process_list != NULL){
-    while(true){
-      fd_set rfds = rfds_orig;
-      int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
-      if (select_ret == -1){
-	perror(argv[0]);
-	goto end;
-      }else{	
-	for(process *process_itr = process_list; process_itr != NULL;
-	    process_itr = process_itr->next){
-	  if(FD_ISSET(process_itr->fd, &rfds)){
-	    if(process_itr->buffer_length + BUFFER_SIZE
-	       > process_itr->buffer_size){
-		process_itr->buffer = realloc(process_itr->buffer,
-					      process_itr->buffer_size
-					      + (size_t) BUFFER_SIZE);
-		if (process_itr->buffer == NULL){
-		  perror(argv[0]);
-		  goto end;
-		}
-		process_itr->buffer_size += BUFFER_SIZE;
-	    }
-	    ret = read(process_itr->fd, process_itr->buffer
-		       + process_itr->buffer_length, BUFFER_SIZE);
-	    if(ret < 0){
-	      /* Read error from this process; ignore it */
-	      continue;
-	    }
-	    process_itr->buffer_length += (size_t) ret;
-	    if(ret == 0){
-	      /* got EOF */
-	      /* wait for process exit */
-	      int status;
-	      waitpid(process_itr->pid, &status, 0);
-	      if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
-		for(size_t written = 0;
-		    written < process_itr->buffer_length;){
-		  ret = write(STDOUT_FILENO,
-			      process_itr->buffer + written,
-			      process_itr->buffer_length - written);
-		  if(ret < 0){
-		    perror(argv[0]);
-		    goto end;
-		  }
-		  written += (size_t)ret;
-		}
-		goto end;
-	      } else {
-		FD_CLR(process_itr->fd, &rfds_orig);
-	      }
-	    }
-	  }
-	}
-      }
-    }
-  }
-  
- end:
-  for(process *process_itr = process_list; process_itr != NULL;
-      process_itr = process_itr->next){
-    close(process_itr->fd);
-    kill(process_itr->pid, SIGTERM);
-    free(process_itr->buffer);
-  }
-  
-  while(true){
-    int status;
-    ret = wait(&status);
-    if (ret == -1){
-      if(errno != ECHILD){
-	perror("wait");
-      }
-      break;
-    }
-  }  
-  return EXIT_SUCCESS;
-}

=== removed directory 'plugins.d'
=== removed file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-07-22 06:23:29 +0000
+++ plugins.d/mandosclient.c	1970-01-01 00:00:00 +0000
@@ -1,726 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Mandos client - get and decrypt data from a Mandos server
- *
- * This program is partly derived from an example program for an Avahi
- * service browser, downloaded from
- * <http://avahi.org/browser/examples/core-browse-services.c>.  This
- * includes the following functions: "resolve_callback",
- * "browse_callback", and parts of "main".
- * 
- * Everything else is Copyright © 2007-2008 Teddy Hogeborn and Björn
- * Påhlsson.
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _FORTIFY_SOURCE 2
-
-#define _LARGEFILE_SOURCE
-#define _FILE_OFFSET_BITS 64
-
-#include <stdio.h>
-#include <assert.h>
-#include <stdlib.h>
-#include <time.h>
-#include <net/if.h>		/* if_nametoindex */
-
-#include <avahi-core/core.h>
-#include <avahi-core/lookup.h>
-#include <avahi-core/log.h>
-#include <avahi-common/simple-watch.h>
-#include <avahi-common/malloc.h>
-#include <avahi-common/error.h>
-
-//mandos client part
-#include <sys/types.h>		/* socket(), inet_pton() */
-#include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   struct in6_addr, inet_pton() */
-#include <gnutls/gnutls.h>	/* All GnuTLS stuff */
-#include <gnutls/openpgp.h>	/* GnuTLS with openpgp stuff */
-
-#include <unistd.h>		/* close() */
-#include <netinet/in.h>
-#include <stdbool.h>		/* true */
-#include <string.h>		/* memset */
-#include <arpa/inet.h>		/* inet_pton() */
-#include <iso646.h>		/* not */
-
-// gpgme
-#include <errno.h>		/* perror() */
-#include <gpgme.h>
-
-// getopt long
-#include <getopt.h>
-
-#ifndef CERT_ROOT
-#define CERT_ROOT "/conf/conf.d/cryptkeyreq/"
-#endif
-#define CERTFILE CERT_ROOT "openpgp-client.txt"
-#define KEYFILE CERT_ROOT "openpgp-client-key.txt"
-#define BUFFER_SIZE 256
-#define DH_BITS 1024
-
-bool debug = false;
-
-typedef struct {
-  gnutls_session_t session;
-  gnutls_certificate_credentials_t cred;
-  gnutls_dh_params_t dh_params;
-} encrypted_session;
-
-
-ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
-			    char **new_packet, const char *homedir){
-  gpgme_data_t dh_crypto, dh_plain;
-  gpgme_ctx_t ctx;
-  gpgme_error_t rc;
-  ssize_t ret;
-  ssize_t new_packet_capacity = 0;
-  ssize_t new_packet_length = 0;
-  gpgme_engine_info_t engine_info;
-
-  if (debug){
-    fprintf(stderr, "Trying to decrypt OpenPGP packet\n");
-  }
-  
-  /* Init GPGME */
-  gpgme_check_version(NULL);
-  gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
-  
-  /* Set GPGME home directory */
-  rc = gpgme_get_engine_info (&engine_info);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
-  while(engine_info != NULL){
-    if(engine_info->protocol == GPGME_PROTOCOL_OpenPGP){
-      gpgme_set_engine_info(GPGME_PROTOCOL_OpenPGP,
-			    engine_info->file_name, homedir);
-      break;
-    }
-    engine_info = engine_info->next;
-  }
-  if(engine_info == NULL){
-    fprintf(stderr, "Could not set home dir to %s\n", homedir);
-    return -1;
-  }
-  
-  /* Create new GPGME data buffer from packet buffer */
-  rc = gpgme_data_new_from_mem(&dh_crypto, packet, packet_size, 0);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
-  
-  /* Create new empty GPGME data buffer for the plaintext */
-  rc = gpgme_data_new(&dh_plain);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
-  
-  /* Create new GPGME "context" */
-  rc = gpgme_new(&ctx);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_new: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
-  
-  /* Decrypt data from the FILE pointer to the plaintext data
-     buffer */
-  rc = gpgme_op_decrypt(ctx, dh_crypto, dh_plain);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
-
-  if(debug){
-    fprintf(stderr, "Decryption of OpenPGP packet succeeded\n");
-  }
-
-  if (debug){
-    gpgme_decrypt_result_t result;
-    result = gpgme_op_decrypt_result(ctx);
-    if (result == NULL){
-      fprintf(stderr, "gpgme_op_decrypt_result failed\n");
-    } else {
-      fprintf(stderr, "Unsupported algorithm: %s\n",
-	      result->unsupported_algorithm);
-      fprintf(stderr, "Wrong key usage: %d\n",
-	      result->wrong_key_usage);
-      if(result->file_name != NULL){
-	fprintf(stderr, "File name: %s\n", result->file_name);
-      }
-      gpgme_recipient_t recipient;
-      recipient = result->recipients;
-      if(recipient){
-	while(recipient != NULL){
-	  fprintf(stderr, "Public key algorithm: %s\n",
-		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Secret key available: %s\n",
-		  recipient->status == GPG_ERR_NO_SECKEY
-		  ? "No" : "Yes");
-	  recipient = recipient->next;
-	}
-      }
-    }
-  }
-  
-  /* Delete the GPGME FILE pointer cryptotext data buffer */
-  gpgme_data_release(dh_crypto);
-  
-  /* Seek back to the beginning of the GPGME plaintext data buffer */
-  gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET);
-
-  *new_packet = 0;
-  while(true){
-    if (new_packet_length + BUFFER_SIZE > new_packet_capacity){
-      *new_packet = realloc(*new_packet,
-			    (unsigned int)new_packet_capacity
-			    + BUFFER_SIZE);
-      if (*new_packet == NULL){
-	perror("realloc");
-	return -1;
-      }
-      new_packet_capacity += BUFFER_SIZE;
-    }
-    
-    ret = gpgme_data_read(dh_plain, *new_packet + new_packet_length,
-			  BUFFER_SIZE);
-    /* Print the data, if any */
-    if (ret == 0){
-      break;
-    }
-    if(ret < 0){
-      perror("gpgme_data_read");
-      return -1;
-    }
-    new_packet_length += ret;
-  }
-
-  /* FIXME: check characters before printing to screen so to not print
-     terminal control characters */
-  /*   if(debug){ */
-  /*     fprintf(stderr, "decrypted password is: "); */
-  /*     fwrite(*new_packet, 1, new_packet_length, stderr); */
-  /*     fprintf(stderr, "\n"); */
-  /*   } */
-  
-  /* Delete the GPGME plaintext data buffer */
-  gpgme_data_release(dh_plain);
-  return new_packet_length;
-}
-
-static const char * safer_gnutls_strerror (int value) {
-  const char *ret = gnutls_strerror (value);
-  if (ret == NULL)
-    ret = "(unknown)";
-  return ret;
-}
-
-void debuggnutls(__attribute__((unused)) int level,
-		 const char* string){
-  fprintf(stderr, "%s", string);
-}
-
-int initgnutls(encrypted_session *es){
-  const char *err;
-  int ret;
-  
-  if(debug){
-    fprintf(stderr, "Initializing GnuTLS\n");
-  }
-  
-  if ((ret = gnutls_global_init ())
-      != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "global_init: %s\n", safer_gnutls_strerror(ret));
-    return -1;
-  }
-
-  if (debug){
-    gnutls_global_set_log_level(11);
-    gnutls_global_set_log_function(debuggnutls);
-  }
-  
-  /* openpgp credentials */
-  if ((ret = gnutls_certificate_allocate_credentials (&es->cred))
-      != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "memory error: %s\n",
-	     safer_gnutls_strerror(ret));
-    return -1;
-  }
-  
-  if(debug){
-    fprintf(stderr, "Attempting to use OpenPGP certificate %s"
-	    " and keyfile %s as GnuTLS credentials\n", CERTFILE,
-	    KEYFILE);
-  }
-  
-  ret = gnutls_certificate_set_openpgp_key_file
-    (es->cred, CERTFILE, KEYFILE, GNUTLS_OPENPGP_FMT_BASE64);
-  if (ret != GNUTLS_E_SUCCESS) {
-    fprintf
-      (stderr, "Error[%d] while reading the OpenPGP key pair ('%s',"
-       " '%s')\n",
-       ret, CERTFILE, KEYFILE);
-    fprintf(stdout, "The Error is: %s\n",
-	    safer_gnutls_strerror(ret));
-    return -1;
-  }
-  
-  //GnuTLS server initialization
-  if ((ret = gnutls_dh_params_init (&es->dh_params))
-      != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "Error in dh parameter initialization: %s\n",
-	     safer_gnutls_strerror(ret));
-    return -1;
-  }
-  
-  if ((ret = gnutls_dh_params_generate2 (es->dh_params, DH_BITS))
-      != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "Error in prime generation: %s\n",
-	     safer_gnutls_strerror(ret));
-    return -1;
-  }
-  
-  gnutls_certificate_set_dh_params (es->cred, es->dh_params);
-  
-  // GnuTLS session creation
-  if ((ret = gnutls_init (&es->session, GNUTLS_SERVER))
-      != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
-	    safer_gnutls_strerror(ret));
-  }
-  
-  if ((ret = gnutls_priority_set_direct (es->session, "NORMAL", &err))
-      != GNUTLS_E_SUCCESS) {
-    fprintf(stderr, "Syntax error at: %s\n", err);
-    fprintf(stderr, "GnuTLS error: %s\n",
-	    safer_gnutls_strerror(ret));
-    return -1;
-  }
-  
-  if ((ret = gnutls_credentials_set
-       (es->session, GNUTLS_CRD_CERTIFICATE, es->cred))
-      != GNUTLS_E_SUCCESS) {
-    fprintf(stderr, "Error setting a credentials set: %s\n",
-	    safer_gnutls_strerror(ret));
-    return -1;
-  }
-  
-  /* ignore client certificate if any. */
-  gnutls_certificate_server_set_request (es->session,
-					 GNUTLS_CERT_IGNORE);
-  
-  gnutls_dh_set_prime_bits (es->session, DH_BITS);
-  
-  return 0;
-}
-
-void empty_log(__attribute__((unused)) AvahiLogLevel level,
-	       __attribute__((unused)) const char *txt){}
-
-int start_mandos_communication(const char *ip, uint16_t port,
-			       unsigned int if_index){
-  int ret, tcp_sd;
-  struct sockaddr_in6 to;
-  encrypted_session es;
-  char *buffer = NULL;
-  char *decrypted_buffer;
-  size_t buffer_length = 0;
-  size_t buffer_capacity = 0;
-  ssize_t decrypted_buffer_size;
-  size_t written = 0;
-  int retval = 0;
-  char interface[IF_NAMESIZE];
-  
-  if(debug){
-    fprintf(stderr, "Setting up a tcp connection to %s\n", ip);
-  }
-  
-  tcp_sd = socket(PF_INET6, SOCK_STREAM, 0);
-  if(tcp_sd < 0) {
-    perror("socket");
-    return -1;
-  }
-  
-  if(if_indextoname(if_index, interface) == NULL){
-    if(debug){
-      perror("if_indextoname");
-    }
-    return -1;
-  }
-  
-  if(debug){
-    fprintf(stderr, "Binding to interface %s\n", interface);
-  }
-  
-  memset(&to,0,sizeof(to));	/* Spurious warning */
-  to.sin6_family = AF_INET6;
-  ret = inet_pton(AF_INET6, ip, &to.sin6_addr);
-  if (ret < 0 ){
-    perror("inet_pton");
-    return -1;
-  }  
-  if(ret == 0){
-    fprintf(stderr, "Bad address: %s\n", ip);
-    return -1;
-  }
-  to.sin6_port = htons(port);	/* Spurious warning */
-  
-  to.sin6_scope_id = (uint32_t)if_index;
-  
-  if(debug){
-    fprintf(stderr, "Connection to: %s\n", ip);
-  }
-  
-  ret = connect(tcp_sd, (struct sockaddr *) &to, sizeof(to));
-  if (ret < 0){
-    perror("connect");
-    return -1;
-  }
-  
-  ret = initgnutls (&es);
-  if (ret != 0){
-    retval = -1;
-    return -1;
-  }
-  
-  gnutls_transport_set_ptr (es.session,
-			    (gnutls_transport_ptr_t) tcp_sd);
-  
-  if(debug){
-    fprintf(stderr, "Establishing TLS session with %s\n", ip);
-  }
-  
-  ret = gnutls_handshake (es.session);
-  
-  if (ret != GNUTLS_E_SUCCESS){
-    if(debug){
-      fprintf(stderr, "\n*** Handshake failed ***\n");
-      gnutls_perror (ret);
-    }
-    retval = -1;
-    goto exit;
-  }
-  
-  //Retrieve OpenPGP packet that contains the wanted password
-  
-  if(debug){
-    fprintf(stderr, "Retrieving pgp encrypted password from %s\n",
-	    ip);
-  }
-
-  while(true){
-    if (buffer_length + BUFFER_SIZE > buffer_capacity){
-      buffer = realloc(buffer, buffer_capacity + BUFFER_SIZE);
-      if (buffer == NULL){
-	perror("realloc");
-	goto exit;
-      }
-      buffer_capacity += BUFFER_SIZE;
-    }
-    
-    ret = gnutls_record_recv
-      (es.session, buffer+buffer_length, BUFFER_SIZE);
-    if (ret == 0){
-      break;
-    }
-    if (ret < 0){
-      switch(ret){
-      case GNUTLS_E_INTERRUPTED:
-      case GNUTLS_E_AGAIN:
-	break;
-      case GNUTLS_E_REHANDSHAKE:
-	ret = gnutls_handshake (es.session);
-	if (ret < 0){
-	  fprintf(stderr, "\n*** Handshake failed ***\n");
-	  gnutls_perror (ret);
-	  retval = -1;
-	  goto exit;
-	}
-	break;
-      default:
-	fprintf(stderr, "Unknown error while reading data from"
-		" encrypted session with mandos server\n");
-	retval = -1;
-	gnutls_bye (es.session, GNUTLS_SHUT_RDWR);
-	goto exit;
-      }
-    } else {
-      buffer_length += (size_t) ret;
-    }
-  }
-  
-  if (buffer_length > 0){
-    decrypted_buffer_size = pgp_packet_decrypt(buffer,
-					       buffer_length,
-					       &decrypted_buffer,
-					       CERT_ROOT);
-    if (decrypted_buffer_size >= 0){
-      while(written < decrypted_buffer_size){
-	ret = (int)fwrite (decrypted_buffer + written, 1,
-			   (size_t)decrypted_buffer_size - written,
-			   stdout);
-	if(ret == 0 and ferror(stdout)){
-	  if(debug){
-	    fprintf(stderr, "Error writing encrypted data: %s\n",
-		    strerror(errno));
-	  }
-	  retval = -1;
-	  break;
-	}
-	written += (size_t)ret;
-      }
-      free(decrypted_buffer);
-    } else {
-      retval = -1;
-    }
-  }
-
-  //shutdown procedure
-
-  if(debug){
-    fprintf(stderr, "Closing TLS session\n");
-  }
-
-  free(buffer);
-  gnutls_bye (es.session, GNUTLS_SHUT_RDWR);
- exit:
-  close(tcp_sd);
-  gnutls_deinit (es.session);
-  gnutls_certificate_free_credentials (es.cred);
-  gnutls_global_deinit ();
-  return retval;
-}
-
-static AvahiSimplePoll *simple_poll = NULL;
-static AvahiServer *server = NULL;
-
-static void resolve_callback(
-    AvahiSServiceResolver *r,
-    AvahiIfIndex interface,
-    AVAHI_GCC_UNUSED AvahiProtocol protocol,
-    AvahiResolverEvent event,
-    const char *name,
-    const char *type,
-    const char *domain,
-    const char *host_name,
-    const AvahiAddress *address,
-    uint16_t port,
-    AVAHI_GCC_UNUSED AvahiStringList *txt,
-    AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
-    AVAHI_GCC_UNUSED void* userdata) {
-    
-  assert(r);			/* Spurious warning */
-  
-  /* Called whenever a service has been resolved successfully or
-     timed out */
-  
-  switch (event) {
-  default:
-  case AVAHI_RESOLVER_FAILURE:
-    fprintf(stderr, "(Resolver) Failed to resolve service '%s' of"
-	    " type '%s' in domain '%s': %s\n", name, type, domain,
-	    avahi_strerror(avahi_server_errno(server)));
-    break;
-    
-  case AVAHI_RESOLVER_FOUND:
-    {
-      char ip[AVAHI_ADDRESS_STR_MAX];
-      avahi_address_snprint(ip, sizeof(ip), address);
-      if(debug){
-	fprintf(stderr, "Mandos server \"%s\" found on %s (%s) on"
-		" port %d\n", name, host_name, ip, port);
-      }
-      int ret = start_mandos_communication(ip, port,
-					   (unsigned int) interface);
-      if (ret == 0){
-	exit(EXIT_SUCCESS);
-      }
-    }
-  }
-  avahi_s_service_resolver_free(r);
-}
-
-static void browse_callback(
-    AvahiSServiceBrowser *b,
-    AvahiIfIndex interface,
-    AvahiProtocol protocol,
-    AvahiBrowserEvent event,
-    const char *name,
-    const char *type,
-    const char *domain,
-    AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
-    void* userdata) {
-    
-    AvahiServer *s = userdata;
-    assert(b);			/* Spurious warning */
-    
-    /* Called whenever a new services becomes available on the LAN or
-       is removed from the LAN */
-    
-    switch (event) {
-    default:
-    case AVAHI_BROWSER_FAILURE:
-      
-      fprintf(stderr, "(Browser) %s\n",
-	      avahi_strerror(avahi_server_errno(server)));
-      avahi_simple_poll_quit(simple_poll);
-      return;
-      
-    case AVAHI_BROWSER_NEW:
-      /* We ignore the returned resolver object. In the callback
-	 function we free it. If the server is terminated before
-	 the callback function is called the server will free
-	 the resolver for us. */
-      
-      if (!(avahi_s_service_resolver_new(s, interface, protocol, name,
-					 type, domain,
-					 AVAHI_PROTO_INET6, 0,
-					 resolve_callback, s)))
-	fprintf(stderr, "Failed to resolve service '%s': %s\n", name,
-		avahi_strerror(avahi_server_errno(s)));
-      break;
-      
-    case AVAHI_BROWSER_REMOVE:
-      break;
-      
-    case AVAHI_BROWSER_ALL_FOR_NOW:
-    case AVAHI_BROWSER_CACHE_EXHAUSTED:
-      break;
-    }
-}
-
-int main(AVAHI_GCC_UNUSED int argc, AVAHI_GCC_UNUSED char*argv[]) {
-    AvahiServerConfig config;
-    AvahiSServiceBrowser *sb = NULL;
-    int error;
-    int ret;
-    int returncode = EXIT_SUCCESS;
-    const char *interface = "eth0";
-    
-    while (true){
-      static struct option long_options[] = {
-	{"debug", no_argument, (int *)&debug, 1},
-	{"interface", required_argument, 0, 'i'},
-	{0, 0, 0, 0} };
-      
-      int option_index = 0;
-      ret = getopt_long (argc, argv, "i:", long_options,
-			 &option_index);
-      
-      if (ret == -1){
-	break;
-      }
-      
-      switch(ret){
-      case 0:
-	break;
-      case 'i':
-	interface = optarg;
-	break;
-      default:
-	exit(EXIT_FAILURE);
-      }
-    }
-    
-    if (not debug){
-      avahi_set_log_function(empty_log);
-    }
-    
-    /* Initialize the psuedo-RNG */
-    srand((unsigned int) time(NULL));
-
-    /* Allocate main loop object */
-    if (!(simple_poll = avahi_simple_poll_new())) {
-        fprintf(stderr, "Failed to create simple poll object.\n");
-	
-        goto exit;
-    }
-
-    /* Do not publish any local records */
-    avahi_server_config_init(&config);
-    config.publish_hinfo = 0;
-    config.publish_addresses = 0;
-    config.publish_workstation = 0;
-    config.publish_domain = 0;
-
-    /* Allocate a new server */
-    server = avahi_server_new(avahi_simple_poll_get(simple_poll),
-			      &config, NULL, NULL, &error);
-
-    /* Free the configuration data */
-    avahi_server_config_free(&config);
-
-    /* Check if creating the server object succeeded */
-    if (!server) {
-        fprintf(stderr, "Failed to create server: %s\n",
-		avahi_strerror(error));
-	returncode = EXIT_FAILURE;
-        goto exit;
-    }
-    
-    /* Create the service browser */
-    sb = avahi_s_service_browser_new(server,
-				     (AvahiIfIndex)
-				     if_nametoindex(interface),
-				     AVAHI_PROTO_INET6,
-				     "_mandos._tcp", NULL, 0,
-				     browse_callback, server);
-    if (!sb) {
-        fprintf(stderr, "Failed to create service browser: %s\n",
-		avahi_strerror(avahi_server_errno(server)));
-	returncode = EXIT_FAILURE;
-        goto exit;
-    }
-    
-    /* Run the main loop */
-
-    if (debug){
-      fprintf(stderr, "Starting avahi loop search\n");
-    }
-    
-    avahi_simple_poll_loop(simple_poll);
-    
- exit:
-
-    if (debug){
-      fprintf(stderr, "%s exiting\n", argv[0]);
-    }
-    
-    /* Cleanup things */
-    if (sb)
-        avahi_s_service_browser_free(sb);
-    
-    if (server)
-        avahi_server_free(server);
-
-    if (simple_poll)
-        avahi_simple_poll_free(simple_poll);
-
-    return returncode;
-}

=== removed file 'plugins.d/passprompt.c'
--- plugins.d/passprompt.c	2008-07-21 15:34:44 +0000
+++ plugins.d/passprompt.c	1970-01-01 00:00:00 +0000
@@ -1,177 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from the terminal and print it
- *
- * Copyright © 2007-2008 Teddy Hogeborn and Björn Påhlsson.
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _GNU_SOURCE		/* getline() */
-#define _FORTIFY_SOURCE 2
-
-#include <termios.h> 		/* struct termios, tcsetattr(),
-				   TCSAFLUSH, tcgetattr(), ECHO */
-#include <unistd.h>		/* struct termios, tcsetattr(),
-				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO */
-#include <signal.h>		/* sig_atomic_t, raise(), struct
-				   sigaction, sigemptyset(),
-				   sigaction(), sigaddset(), SIGINT,
-				   SIGQUIT, SIGHUP, SIGTERM */
-#include <stddef.h>		/* NULL, size_t */
-#include <sys/types.h>		/* ssize_t */
-#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getopt_long */
-#include <stdio.h>		/* fprintf(), stderr, getline(),
-				   stdin, feof(), perror(), fputc(),
-				   stdout, getopt_long */
-#include <errno.h>		/* errno, EINVAL */
-#include <iso646.h>		/* or, not */
-#include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex, strncmp, strcmp */
-#include <getopt.h>		/* getopt_long */
-
-volatile bool quit_now = false;
-bool debug = false;
-
-void termination_handler(__attribute__((unused))int signum){
-  quit_now = true;
-}
-
-int main(int argc, char **argv){
-  ssize_t ret;
-  size_t n;
-  struct termios t_new, t_old;
-  char *buffer = NULL;
-  char *prefix = NULL;
-  int status = EXIT_SUCCESS;
-  struct sigaction old_action,
-    new_action = { .sa_handler = termination_handler,
-		   .sa_flags = 0 };
-
-  while (true){
-    static struct option long_options[] = {
-      {"debug", no_argument, (int *)&debug, 1},
-      {"prefix", required_argument, 0, 'p'},
-      {0, 0, 0, 0} };
-
-    int option_index = 0;
-    ret = getopt_long (argc, argv, "p:", long_options, &option_index);
-
-    if (ret == -1){
-      break;
-    }
-      
-    switch(ret){
-    case 0:
-      break;
-    case 'p':
-      prefix = optarg;
-      break;
-    default:
-      fprintf(stderr, "bad arguments\n");
-      exit(EXIT_FAILURE);
-    }
-  }
-      
-  if (debug){
-    fprintf(stderr, "Starting %s\n", argv[0]);
-  }
-  if (debug){
-    fprintf(stderr, "Storing current terminal attributes\n");
-  }
-  
-  if (tcgetattr(STDIN_FILENO, &t_old) != 0){
-    return EXIT_FAILURE;
-  }
-  
-  sigemptyset(&new_action.sa_mask);
-  sigaddset(&new_action.sa_mask, SIGINT);
-  sigaddset(&new_action.sa_mask, SIGQUIT);
-  sigaddset(&new_action.sa_mask, SIGHUP);
-  sigaddset(&new_action.sa_mask, SIGTERM);
-  sigaction(SIGINT, NULL, &old_action);
-  if (old_action.sa_handler != SIG_IGN)
-    sigaction(SIGINT, &new_action, NULL);
-  sigaction(SIGQUIT, NULL, &old_action);
-  if (old_action.sa_handler != SIG_IGN)
-    sigaction(SIGQUIT, &new_action, NULL);
-  sigaction(SIGHUP, NULL, &old_action);
-  if (old_action.sa_handler != SIG_IGN)
-    sigaction(SIGHUP, &new_action, NULL);
-  sigaction(SIGTERM, NULL, &old_action);
-  if (old_action.sa_handler != SIG_IGN)
-    sigaction(SIGTERM, &new_action, NULL);
-
-  
-  if (debug){
-    fprintf(stderr, "Removing echo flag from terminal attributes\n");
-  }
-  
-  t_new = t_old;
-  t_new.c_lflag &= ~ECHO;
-  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
-    perror("tcsetattr-echo");
-    return EXIT_FAILURE;
-  }
-
-  if (debug){
-    fprintf(stderr, "Waiting for input from stdin \n");
-  }
-  while(true){
-    if (quit_now){
-      status = EXIT_FAILURE;
-      break;
-    }
-
-    if(prefix){
-      fprintf(stderr, "%s Password: ", prefix);
-    } else {
-      fprintf(stderr, "Password: ");
-    }      
-    ret = getline(&buffer, &n, stdin);
-    if (ret > 0){
-      fprintf(stdout, "%s", buffer);
-      status = EXIT_SUCCESS;
-      break;
-    }
-    // ret == 0 makes no other sence than to retry to read from stdin
-    if (ret < 0){
-      if (errno != EINTR and not feof(stdin)){
-	perror("getline");
-	status = EXIT_FAILURE;
-	break;
-      }
-    }
-    fputc('\n', stderr);
-  }
-
-  if (debug){
-    fprintf(stderr, "Restoring terminal attributes\n");
-  }
-  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
-    perror("tcsetattr+echo");
-  }
-
-  if (debug){
-    fprintf(stderr, "%s is exiting\n", argv[0]);
-  }
-  
-  return status;
-}

=== added file 'server.cpp'
--- server.cpp	1970-01-01 00:00:00 +0000
+++ server.cpp	2007-10-20 21:38:25 +0000
@@ -0,0 +1,301 @@
+extern "C" {
+#include <sys/types.h> //socket, setsockopt, bind, listen, accept,
+  // inet_ntop,
+#include <sys/socket.h> //socket, setsockopt, bind, listen, accept,
+  // inet_ntop
+#include <sys/ioctl.h> //ioctl, sockaddr_ll, ifreq
+#include <unistd.h> //write, close
+#include <netinet/ip.h> 	// sockaddr_in
+#include <gnutls/gnutls.h>
+#include <gnutls/x509.h> 	// gnutls_x509_crt_init, gnutls_x509_crt_import, gnutls_x509_crt_get_dn
+#include <arpa/inet.h> 		// inet_ntop, htons
+#include <net/if.h> //ifreq
+}
+
+#include <cstdio>
+#include <cstring>
+#include <cerrno>
+#include <algorithm> 		// std::max
+#include <cstdlib> 		// exit()
+
+#define SOCKET_ERR(err,s) if(err<0) {perror(s);exit(1);}
+
+#define PORT 49001
+#define KEYFILE "key.pem"
+#define CERTFILE "cert.pem"
+#define CAFILE "ca.pem"
+#define CRLFILE "crl.pem"
+#define DH_BITS 1024
+
+/* These are global */
+gnutls_certificate_credentials_t x509_cred;
+
+static gnutls_dh_params_t dh_params;
+
+static int
+generate_dh_params ()
+{
+
+  /* Generate Diffie Hellman parameters - for use with DHE
+   * kx algorithms. These should be discarded and regenerated
+   * once a day, once a week or once a month. Depending on the
+   * security requirements.
+   */
+  gnutls_dh_params_init (&dh_params);
+  gnutls_dh_params_generate2 (dh_params, DH_BITS);
+
+  return 0;
+}
+
+gnutls_session_t
+initialize_tls_session ()
+{
+  gnutls_session_t session;
+
+  gnutls_global_init ();
+
+  gnutls_certificate_allocate_credentials (&x509_cred);
+  gnutls_certificate_set_x509_trust_file (x509_cred, CAFILE,
+					  GNUTLS_X509_FMT_PEM);
+  gnutls_certificate_set_x509_crl_file (x509_cred, CRLFILE,
+					GNUTLS_X509_FMT_PEM);
+  gnutls_certificate_set_x509_key_file (x509_cred, CERTFILE, KEYFILE,
+					GNUTLS_X509_FMT_PEM);
+
+  generate_dh_params ();
+  gnutls_certificate_set_dh_params (x509_cred, dh_params);
+
+  gnutls_init (&session, GNUTLS_SERVER);
+  gnutls_set_default_priority (session);
+  gnutls_credentials_set (session, GNUTLS_CRD_CERTIFICATE, x509_cred);
+
+  // request client certificate if any.
+
+  gnutls_certificate_server_set_request (session, GNUTLS_CERT_REQUEST);
+  gnutls_dh_set_prime_bits (session, DH_BITS);
+
+  return session;
+}
+
+
+void udpreply(int &sd){
+  struct sockaddr_in6 sa_cli;
+  int ret;
+  char buffer[512];
+
+  {
+    socklen_t sa_cli_len = sizeof(sa_cli);
+    ret = recvfrom(sd, buffer, 512,0,
+		   reinterpret_cast<sockaddr *>(& sa_cli), & sa_cli_len);
+    SOCKET_ERR (ret, "recvfrom");
+  }
+
+  if (strncmp(buffer,"Marco", 5) == 0){
+    ret = sendto(sd, "Polo", 4, 0, reinterpret_cast<sockaddr *>(& sa_cli),
+		 sizeof(sa_cli));
+    SOCKET_ERR (ret, "sendto");
+  }
+
+}
+
+void tcpreply(int sd, struct sockaddr_in6 sa_cli, gnutls_session_t session){
+  int ret;
+  unsigned int status;
+  char buffer[512];
+
+  printf ("- connection from %s, port %d\n",
+	  inet_ntop (AF_INET6, &sa_cli.sin6_addr, buffer,
+		     sizeof (buffer)), ntohs (sa_cli.sin6_port));
+
+  
+  gnutls_transport_set_ptr (session, reinterpret_cast<gnutls_transport_ptr_t> (sd));
+  
+
+  ret = gnutls_handshake (session);
+  if (ret < 0)
+    {
+      close (sd);
+      gnutls_deinit (session);
+      fprintf (stderr, "*** Handshake has failed (%s)\n\n",
+	       gnutls_strerror (ret));
+      exit(1);
+    }
+  printf ("- Handshake was completed\n");
+
+  //time to validate
+
+    ret = gnutls_certificate_verify_peers2 (session, &status);
+
+  if (ret < 0)
+    {
+      printf ("Verify failed\n");
+      exit(1);
+    }
+
+  if (status & GNUTLS_CERT_INVALID)
+    printf ("The certificate is not trusted.\n");
+
+  if (status & GNUTLS_CERT_SIGNER_NOT_FOUND)
+    printf ("The certificate hasn't got a known issuer.\n");
+
+  if (status & GNUTLS_CERT_REVOKED)
+    printf ("The certificate has been revoked.\n");
+
+  if (gnutls_certificate_type_get (session) != GNUTLS_CRT_X509){
+    printf("Recived certificate not X.509\n");
+    exit(1);
+  }
+  {
+    const gnutls_datum_t *cert_list;
+    unsigned int cert_list_size = 0;
+    gnutls_x509_crt_t cert;
+    size_t size;
+    char dn[128];
+    
+    cert_list = gnutls_certificate_get_peers (session, &cert_list_size);
+    
+    printf ("Peer provided %d certificates.\n", cert_list_size);
+    
+    if (cert_list_size == 0){
+      printf("No certificates recived\n"); //should never happen because verify_peers2 should fail if so
+      exit(1);
+    }
+    
+    gnutls_x509_crt_init (&cert);
+    
+    // XXX -Checking only first cert, might want to check them all
+    gnutls_x509_crt_import (cert, &cert_list[0], GNUTLS_X509_FMT_DER);
+    
+    size = sizeof (dn);
+    gnutls_x509_crt_get_dn (cert, dn, &size);
+    
+    printf ("DN: %s\n", dn);
+  }
+  
+  ret = gnutls_record_recv (session, buffer, sizeof(buffer));
+
+  if (ret > 0)
+    {
+      write(1, buffer, ret);
+    }
+  else {
+    fprintf (stderr, "\n*** Received corrupted "
+	     "data(%d). Closing the connection.\n\n", ret);
+  }
+  
+  gnutls_bye (session, GNUTLS_SHUT_WR);
+  close(sd);
+  gnutls_deinit (session);
+  gnutls_certificate_free_credentials (x509_cred);
+  gnutls_global_deinit ();
+}
+
+
+int main (){
+  int ret, err, udp_listen_sd, tcp_listen_sd;
+  struct sockaddr_in6 sa_serv;
+  struct sockaddr_in6 sa_cli;
+
+  int optval = 1;
+  socklen_t client_len;
+
+  gnutls_session_t session;
+
+  fd_set rfds_orig;
+
+  session = initialize_tls_session ();
+
+  //UDP socket creation
+  udp_listen_sd = socket (PF_INET6, SOCK_DGRAM, 0);
+  SOCKET_ERR (udp_listen_sd, "socket");
+
+  memset (&sa_serv, '\0', sizeof (sa_serv));
+  sa_serv.sin6_family = AF_INET6;
+  sa_serv.sin6_addr = in6addr_any; //XXX only listen to link local?
+  sa_serv.sin6_port = htons (PORT);	/* Server Port number */
+
+  ret = setsockopt (udp_listen_sd, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof (int));
+  SOCKET_ERR(ret,"setsockopt reuseaddr");
+
+  ret = setsockopt(udp_listen_sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
+  SOCKET_ERR(ret,"setsockopt bindtodevice");
+
+  {
+    int flag = 1;
+    ret = setsockopt(udp_listen_sd, SOL_SOCKET, SO_BROADCAST, & flag, sizeof(flag));
+    SOCKET_ERR(ret,"setsockopt broadcast");
+  }
+
+  err = bind (udp_listen_sd, reinterpret_cast<const sockaddr *> (& sa_serv),
+	      sizeof (sa_serv));
+  SOCKET_ERR (err, "bind");
+
+  //UDP socket creation done
+
+
+  //TCP socket creation
+
+  tcp_listen_sd = socket(PF_INET6, SOCK_STREAM, 0);
+  SOCKET_ERR(tcp_listen_sd,"socket");
+
+  setsockopt(tcp_listen_sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
+  SOCKET_ERR(ret,"setsockopt bindtodevice");
+  
+  ret = setsockopt (tcp_listen_sd, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof (int));
+  SOCKET_ERR(ret,"setsockopt reuseaddr");
+
+  err = bind (tcp_listen_sd, reinterpret_cast<const sockaddr *> (& sa_serv),
+	      sizeof (sa_serv));
+  SOCKET_ERR (err, "bind");
+
+  err = listen (tcp_listen_sd, 1024);
+  SOCKET_ERR (err, "listen");
+
+  //TCP sockets creation done
+
+  FD_ZERO(&rfds_orig);
+  FD_SET(udp_listen_sd, &rfds_orig);
+  FD_SET(tcp_listen_sd, &rfds_orig);
+
+  printf ("Server ready. Listening to port '%d' on UDP and TCP.\n\n", PORT);
+
+  for(;;){
+    fd_set rfds = rfds_orig;
+
+    ret = select(std::max(udp_listen_sd, tcp_listen_sd)+1, &rfds, 0, 0, 0);
+    SOCKET_ERR(ret,"select");
+
+    if (FD_ISSET(udp_listen_sd, &rfds)){
+      udpreply(udp_listen_sd);
+    }
+
+    if (FD_ISSET(tcp_listen_sd, &rfds)){
+
+      client_len = sizeof(sa_cli);
+
+      int sd = accept (tcp_listen_sd,
+	       reinterpret_cast<struct sockaddr *> (& sa_cli),
+	       &client_len);
+      SOCKET_ERR(sd,"accept"); //xxx not dieing when just connection abort      
+      switch(fork()){
+	case 0:
+	  tcpreply(sd, sa_cli, session);
+	  return 0;
+	  break;
+      case -1:
+	perror("fork");
+	close(tcp_listen_sd);
+	close(udp_listen_sd);
+	return 1;
+	break;
+      default:
+	break;
+      }
+    }
+  }
+
+  close(tcp_listen_sd);
+  close(udp_listen_sd);
+  return 0;
+
+}

=== removed file 'server.py'
--- server.py	2008-07-22 06:23:29 +0000
+++ server.py	1970-01-01 00:00:00 +0000
@@ -1,764 +0,0 @@
-#!/usr/bin/python
-# -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos server - give out binary blobs to connecting clients.
-# 
-# This program is partly derived from an example program for an Avahi
-# service publisher, downloaded from
-# <http://avahi.org/wiki/PythonPublishExample>.  This includes the
-# following functions: "add_service", "remove_service",
-# "server_state_changed", "entry_group_state_changed", and some lines
-# in "main".
-# 
-# Everything else is Copyright © 2007-2008 Teddy Hogeborn and Björn
-# Påhlsson.
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
-# <https://www.fukt.bsnet.se/~teddy/>.
-# 
-
-from __future__ import division
-
-import SocketServer
-import socket
-import select
-from optparse import OptionParser
-import datetime
-import errno
-import gnutls.crypto
-import gnutls.connection
-import gnutls.errors
-import gnutls.library.functions
-import gnutls.library.constants
-import gnutls.library.types
-import ConfigParser
-import sys
-import re
-import os
-import signal
-from sets import Set
-import subprocess
-import atexit
-import stat
-import logging
-import logging.handlers
-
-import dbus
-import gobject
-import avahi
-from dbus.mainloop.glib import DBusGMainLoop
-import ctypes
-
-# Brief description of the operation of this program:
-# 
-# This server announces itself as a Zeroconf service.  Connecting
-# clients use the TLS protocol, with the unusual quirk that this
-# server program acts as a TLS "client" while the connecting clients
-# acts as a TLS "server".  The clients (acting as a TLS "server") must
-# supply an OpenPGP certificate, and the fingerprint of this
-# certificate is used by this server to look up (in a list read from a
-# file at start time) which binary blob to give the client.  No other
-# authentication or authorization is done by this server.
-
-
-logger = logging.Logger('mandos')
-syslogger = logging.handlers.SysLogHandler\
-            (facility = logging.handlers.SysLogHandler.LOG_DAEMON)
-syslogger.setFormatter(logging.Formatter\
-                        ('%(levelname)s: %(message)s'))
-logger.addHandler(syslogger)
-del syslogger
-
-# This variable is used to optionally bind to a specified interface.
-# It is a global variable to fit in with the other variables from the
-# Avahi example code.
-serviceInterface = avahi.IF_UNSPEC
-# From the Avahi example code:
-serviceName = None
-serviceType = "_mandos._tcp" # http://www.dns-sd.org/ServiceTypes.html
-servicePort = None                      # Not known at startup
-serviceTXT = []                         # TXT record for the service
-domain = ""                  # Domain to publish on, default to .local
-host = ""          # Host to publish records for, default to localhost
-group = None #our entry group
-rename_count = 12       # Counter so we only rename after collisions a
-                        # sensible number of times
-# End of Avahi example code
-
-
-class Client(object):
-    """A representation of a client host served by this server.
-    Attributes:
-    name:      string; from the config file, used in log messages
-    fingerprint: string (40 or 32 hexadecimal digits); used to
-                 uniquely identify the client
-    secret:    bytestring; sent verbatim (over TLS) to client
-    fqdn:      string (FQDN); available for use by the checker command
-    created:   datetime.datetime()
-    last_seen: datetime.datetime() or None if not yet seen
-    timeout:   datetime.timedelta(); How long from last_seen until
-                                     this client is invalid
-    interval:  datetime.timedelta(); How often to start a new checker
-    stop_hook: If set, called by stop() as stop_hook(self)
-    checker:   subprocess.Popen(); a running checker process used
-                                   to see if the client lives.
-                                   Is None if no process is running.
-    checker_initiator_tag: a gobject event source tag, or None
-    stop_initiator_tag:    - '' -
-    checker_callback_tag:  - '' -
-    checker_command: string; External command which is run to check if
-                     client lives.  %()s expansions are done at
-                     runtime with vars(self) as dict, so that for
-                     instance %(name)s can be used in the command.
-    Private attibutes:
-    _timeout: Real variable for 'timeout'
-    _interval: Real variable for 'interval'
-    _timeout_milliseconds: Used by gobject.timeout_add()
-    _interval_milliseconds: - '' -
-    """
-    def _set_timeout(self, timeout):
-        "Setter function for 'timeout' attribute"
-        self._timeout = timeout
-        self._timeout_milliseconds = ((self.timeout.days
-                                       * 24 * 60 * 60 * 1000)
-                                      + (self.timeout.seconds * 1000)
-                                      + (self.timeout.microseconds
-                                         // 1000))
-    timeout = property(lambda self: self._timeout,
-                       _set_timeout)
-    del _set_timeout
-    def _set_interval(self, interval):
-        "Setter function for 'interval' attribute"
-        self._interval = interval
-        self._interval_milliseconds = ((self.interval.days
-                                        * 24 * 60 * 60 * 1000)
-                                       + (self.interval.seconds
-                                          * 1000)
-                                       + (self.interval.microseconds
-                                          // 1000))
-    interval = property(lambda self: self._interval,
-                        _set_interval)
-    del _set_interval
-    def __init__(self, name=None, stop_hook=None, fingerprint=None,
-                 secret=None, secfile=None, fqdn=None, timeout=None,
-                 interval=-1, checker=None):
-        """Note: the 'checker' argument sets the 'checker_command'
-        attribute and not the 'checker' attribute.."""
-        self.name = name
-        logger.debug(u"Creating client %r", self.name)
-        # Uppercase and remove spaces from fingerprint
-        # for later comparison purposes with return value of
-        # the fingerprint() function
-        self.fingerprint = fingerprint.upper().replace(u" ", u"")
-        logger.debug(u"  Fingerprint: %s", self.fingerprint)
-        if secret:
-            self.secret = secret.decode(u"base64")
-        elif secfile:
-            sf = open(secfile)
-            self.secret = sf.read()
-            sf.close()
-        else:
-            raise RuntimeError(u"No secret or secfile for client %s"
-                               % self.name)
-        self.fqdn = fqdn                # string
-        self.created = datetime.datetime.now()
-        self.last_seen = None
-        self.timeout = string_to_delta(timeout)
-        self.interval = string_to_delta(interval)
-        self.stop_hook = stop_hook
-        self.checker = None
-        self.checker_initiator_tag = None
-        self.stop_initiator_tag = None
-        self.checker_callback_tag = None
-        self.check_command = checker
-    def start(self):
-        """Start this client's checker and timeout hooks"""
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = gobject.timeout_add\
-                                     (self._interval_milliseconds,
-                                      self.start_checker)
-        # Also start a new checker *right now*.
-        self.start_checker()
-        # Schedule a stop() when 'timeout' has passed
-        self.stop_initiator_tag = gobject.timeout_add\
-                                  (self._timeout_milliseconds,
-                                   self.stop)
-    def stop(self):
-        """Stop this client.
-        The possibility that this client might be restarted is left
-        open, but not currently used."""
-        # If this client doesn't have a secret, it is already stopped.
-        if self.secret:
-            logger.debug(u"Stopping client %s", self.name)
-            self.secret = None
-        else:
-            return False
-        if hasattr(self, "stop_initiator_tag") \
-               and self.stop_initiator_tag:
-            gobject.source_remove(self.stop_initiator_tag)
-            self.stop_initiator_tag = None
-        if hasattr(self, "checker_initiator_tag") \
-               and self.checker_initiator_tag:
-            gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = None
-        self.stop_checker()
-        if self.stop_hook:
-            self.stop_hook(self)
-        # Do not run this again if called by a gobject.timeout_add
-        return False
-    def __del__(self):
-        self.stop_hook = None
-        self.stop()
-    def checker_callback(self, pid, condition):
-        """The checker has completed, so take appropriate actions."""
-        now = datetime.datetime.now()
-        self.checker_callback_tag = None
-        self.checker = None
-        if os.WIFEXITED(condition) \
-               and (os.WEXITSTATUS(condition) == 0):
-            logger.debug(u"Checker for %(name)s succeeded",
-                         vars(self))
-            self.last_seen = now
-            gobject.source_remove(self.stop_initiator_tag)
-            self.stop_initiator_tag = gobject.timeout_add\
-                                      (self._timeout_milliseconds,
-                                       self.stop)
-        elif not os.WIFEXITED(condition):
-            logger.warning(u"Checker for %(name)s crashed?",
-                           vars(self))
-        else:
-            logger.debug(u"Checker for %(name)s failed",
-                         vars(self))
-    def start_checker(self):
-        """Start a new checker subprocess if one is not running.
-        If a checker already exists, leave it running and do
-        nothing."""
-        # The reason for not killing a running checker is that if we
-        # did that, then if a checker (for some reason) started
-        # running slowly and taking more than 'interval' time, the
-        # client would inevitably timeout, since no checker would get
-        # a chance to run to completion.  If we instead leave running
-        # checkers alone, the checker would have to take more time
-        # than 'timeout' for the client to be declared invalid, which
-        # is as it should be.
-        if self.checker is None:
-            try:
-                command = self.check_command % self.fqdn
-            except TypeError:
-                escaped_attrs = dict((key, re.escape(str(val)))
-                                     for key, val in
-                                     vars(self).iteritems())
-                try:
-                    command = self.check_command % escaped_attrs
-                except TypeError, error:
-                    logger.critical(u'Could not format string "%s":'
-                                    u' %s', self.check_command, error)
-                    return True # Try again later
-            try:
-                logger.debug(u"Starting checker %r for %s",
-                             command, self.name)
-                self.checker = subprocess.\
-                               Popen(command,
-                                     close_fds=True, shell=True,
-                                     cwd="/")
-                self.checker_callback_tag = gobject.child_watch_add\
-                                            (self.checker.pid,
-                                             self.checker_callback)
-            except subprocess.OSError, error:
-                logger.error(u"Failed to start subprocess: %s",
-                             error)
-        # Re-run this periodically if run by gobject.timeout_add
-        return True
-    def stop_checker(self):
-        """Force the checker process, if any, to stop."""
-        if self.checker_callback_tag:
-            gobject.source_remove(self.checker_callback_tag)
-            self.checker_callback_tag = None
-        if not hasattr(self, "checker") or self.checker is None:
-            return
-        logger.debug("Stopping checker for %(name)s", vars(self))
-        try:
-            os.kill(self.checker.pid, signal.SIGTERM)
-            #os.sleep(0.5)
-            #if self.checker.poll() is None:
-            #    os.kill(self.checker.pid, signal.SIGKILL)
-        except OSError, error:
-            if error.errno != errno.ESRCH:
-                raise
-        self.checker = None
-    def still_valid(self, now=None):
-        """Has the timeout not yet passed for this client?"""
-        if now is None:
-            now = datetime.datetime.now()
-        if self.last_seen is None:
-            return now < (self.created + self.timeout)
-        else:
-            return now < (self.last_seen + self.timeout)
-
-
-def peer_certificate(session):
-    "Return the peer's OpenPGP certificate as a bytestring"
-    # If not an OpenPGP certificate...
-    if gnutls.library.functions.gnutls_certificate_type_get\
-            (session._c_object) \
-           != gnutls.library.constants.GNUTLS_CRT_OPENPGP:
-        # ...do the normal thing
-        return session.peer_certificate
-    list_size = ctypes.c_uint()
-    cert_list = gnutls.library.functions.gnutls_certificate_get_peers\
-        (session._c_object, ctypes.byref(list_size))
-    if list_size.value == 0:
-        return None
-    cert = cert_list[0]
-    return ctypes.string_at(cert.data, cert.size)
-
-
-def fingerprint(openpgp):
-    "Convert an OpenPGP bytestring to a hexdigit fingerprint string"
-    # New empty GnuTLS certificate
-    crt = gnutls.library.types.gnutls_openpgp_crt_t()
-    gnutls.library.functions.gnutls_openpgp_crt_init\
-        (ctypes.byref(crt))
-    # New GnuTLS "datum" with the OpenPGP public key
-    datum = gnutls.library.types.gnutls_datum_t\
-        (ctypes.cast(ctypes.c_char_p(openpgp),
-                     ctypes.POINTER(ctypes.c_ubyte)),
-         ctypes.c_uint(len(openpgp)))
-    # Import the OpenPGP public key into the certificate
-    ret = gnutls.library.functions.gnutls_openpgp_crt_import\
-        (crt,
-         ctypes.byref(datum),
-         gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
-    # New buffer for the fingerprint
-    buffer = ctypes.create_string_buffer(20)
-    buffer_length = ctypes.c_size_t()
-    # Get the fingerprint from the certificate into the buffer
-    gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint\
-        (crt, ctypes.byref(buffer), ctypes.byref(buffer_length))
-    # Deinit the certificate
-    gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
-    # Convert the buffer to a Python bytestring
-    fpr = ctypes.string_at(buffer, buffer_length.value)
-    # Convert the bytestring to hexadecimal notation
-    hex_fpr = u''.join(u"%02X" % ord(char) for char in fpr)
-    return hex_fpr
-
-
-class tcp_handler(SocketServer.BaseRequestHandler, object):
-    """A TCP request handler class.
-    Instantiated by IPv6_TCPServer for each request to handle it.
-    Note: This will run in its own forked process."""
-    
-    def handle(self):
-        logger.debug(u"TCP connection from: %s",
-                     unicode(self.client_address))
-        session = gnutls.connection.ClientSession(self.request,
-                                                  gnutls.connection.\
-                                                  X509Credentials())
-        
-        #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
-        #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
-        #                "+DHE-DSS"))
-        priority = "NORMAL"
-        if self.server.options.priority:
-            priority = self.server.options.priority
-        gnutls.library.functions.gnutls_priority_set_direct\
-            (session._c_object, priority, None);
-        
-        try:
-            session.handshake()
-        except gnutls.errors.GNUTLSError, error:
-            logger.debug(u"Handshake failed: %s", error)
-            # Do not run session.bye() here: the session is not
-            # established.  Just abandon the request.
-            return
-        try:
-            fpr = fingerprint(peer_certificate(session))
-        except (TypeError, gnutls.errors.GNUTLSError), error:
-            logger.debug(u"Bad certificate: %s", error)
-            session.bye()
-            return
-        logger.debug(u"Fingerprint: %s", fpr)
-        client = None
-        for c in self.server.clients:
-            if c.fingerprint == fpr:
-                client = c
-                break
-        # Have to check if client.still_valid(), since it is possible
-        # that the client timed out while establishing the GnuTLS
-        # session.
-        if (not client) or (not client.still_valid()):
-            if client:
-                logger.debug(u"Client %(name)s is invalid",
-                             vars(client))
-            else:
-                logger.debug(u"Client not found for fingerprint: %s",
-                             fpr)
-            session.bye()
-            return
-        sent_size = 0
-        while sent_size < len(client.secret):
-            sent = session.send(client.secret[sent_size:])
-            logger.debug(u"Sent: %d, remaining: %d",
-                         sent, len(client.secret)
-                         - (sent_size + sent))
-            sent_size += sent
-        session.bye()
-
-
-class IPv6_TCPServer(SocketServer.ForkingTCPServer, object):
-    """IPv6 TCP server.  Accepts 'None' as address and/or port.
-    Attributes:
-        options:        Command line options
-        clients:        Set() of Client objects
-    """
-    address_family = socket.AF_INET6
-    def __init__(self, *args, **kwargs):
-        if "options" in kwargs:
-            self.options = kwargs["options"]
-            del kwargs["options"]
-        if "clients" in kwargs:
-            self.clients = kwargs["clients"]
-            del kwargs["clients"]
-        return super(type(self), self).__init__(*args, **kwargs)
-    def server_bind(self):
-        """This overrides the normal server_bind() function
-        to bind to an interface if one was specified, and also NOT to
-        bind to an address or port if they were not specified."""
-        if self.options.interface:
-            if not hasattr(socket, "SO_BINDTODEVICE"):
-                # From /usr/include/asm-i486/socket.h
-                socket.SO_BINDTODEVICE = 25
-            try:
-                self.socket.setsockopt(socket.SOL_SOCKET,
-                                       socket.SO_BINDTODEVICE,
-                                       self.options.interface)
-            except socket.error, error:
-                if error[0] == errno.EPERM:
-                    logger.warning(u"No permission to"
-                                   u" bind to interface %s",
-                                   self.options.interface)
-                else:
-                    raise error
-        # Only bind(2) the socket if we really need to.
-        if self.server_address[0] or self.server_address[1]:
-            if not self.server_address[0]:
-                in6addr_any = "::"
-                self.server_address = (in6addr_any,
-                                       self.server_address[1])
-            elif self.server_address[1] is None:
-                self.server_address = (self.server_address[0],
-                                       0)
-            return super(type(self), self).server_bind()
-
-
-def string_to_delta(interval):
-    """Parse a string and return a datetime.timedelta
-
-    >>> string_to_delta('7d')
-    datetime.timedelta(7)
-    >>> string_to_delta('60s')
-    datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
-    datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
-    datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
-    datetime.timedelta(7)
-    """
-    try:
-        suffix=unicode(interval[-1])
-        value=int(interval[:-1])
-        if suffix == u"d":
-            delta = datetime.timedelta(value)
-        elif suffix == u"s":
-            delta = datetime.timedelta(0, value)
-        elif suffix == u"m":
-            delta = datetime.timedelta(0, 0, 0, 0, value)
-        elif suffix == u"h":
-            delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-        elif suffix == u"w":
-            delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
-        else:
-            raise ValueError
-    except (ValueError, IndexError):
-        raise ValueError
-    return delta
-
-
-def add_service():
-    """Derived from the Avahi example code"""
-    global group, serviceName, serviceType, servicePort, serviceTXT, \
-           domain, host
-    if group is None:
-        group = dbus.Interface(
-                bus.get_object( avahi.DBUS_NAME,
-                                server.EntryGroupNew()),
-                avahi.DBUS_INTERFACE_ENTRY_GROUP)
-        group.connect_to_signal('StateChanged',
-                                entry_group_state_changed)
-    logger.debug(u"Adding service '%s' of type '%s' ...",
-                 serviceName, serviceType)
-    
-    group.AddService(
-            serviceInterface,           # interface
-            avahi.PROTO_INET6,          # protocol
-            dbus.UInt32(0),             # flags
-            serviceName, serviceType,
-            domain, host,
-            dbus.UInt16(servicePort),
-            avahi.string_array_to_txt_array(serviceTXT))
-    group.Commit()
-
-
-def remove_service():
-    """From the Avahi example code"""
-    global group
-    
-    if not group is None:
-        group.Reset()
-
-
-def server_state_changed(state):
-    """Derived from the Avahi example code"""
-    if state == avahi.SERVER_COLLISION:
-        logger.warning(u"Server name collision")
-        remove_service()
-    elif state == avahi.SERVER_RUNNING:
-        add_service()
-
-
-def entry_group_state_changed(state, error):
-    """Derived from the Avahi example code"""
-    global serviceName, server, rename_count
-    
-    logger.debug(u"state change: %i", state)
-    
-    if state == avahi.ENTRY_GROUP_ESTABLISHED:
-        logger.debug(u"Service established.")
-    elif state == avahi.ENTRY_GROUP_COLLISION:
-        
-        rename_count = rename_count - 1
-        if rename_count > 0:
-            name = server.GetAlternativeServiceName(name)
-            logger.warning(u"Service name collision, "
-                           u"changing name to '%s' ...", name)
-            remove_service()
-            add_service()
-            
-        else:
-            logger.error(u"No suitable service name found after %i"
-                         u" retries, exiting.", n_rename)
-            killme(1)
-    elif state == avahi.ENTRY_GROUP_FAILURE:
-        logger.error(u"Error in group state changed %s",
-                     unicode(error))
-        killme(1)
-
-
-def if_nametoindex(interface):
-    """Call the C function if_nametoindex()"""
-    try:
-        libc = ctypes.cdll.LoadLibrary("libc.so.6")
-        return libc.if_nametoindex(interface)
-    except (OSError, AttributeError):
-        if "struct" not in sys.modules:
-            import struct
-        if "fcntl" not in sys.modules:
-            import fcntl
-        SIOCGIFINDEX = 0x8933      # From /usr/include/linux/sockios.h
-        s = socket.socket()
-        ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                            struct.pack("16s16x", interface))
-        s.close()
-        interface_index = struct.unpack("I", ifreq[16:20])[0]
-        return interface_index
-
-
-def daemon(nochdir, noclose):
-    """See daemon(3).  Standard BSD Unix function.
-    This should really exist as os.daemon, but it doesn't (yet)."""
-    if os.fork():
-        sys.exit()
-    os.setsid()
-    if not nochdir:
-        os.chdir("/")
-    if not noclose:
-        # Close all standard open file descriptors
-        null = os.open("/dev/null", os.O_NOCTTY | os.O_RDWR)
-        if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV,
-                          "/dev/null not a character device")
-        os.dup2(null, sys.stdin.fileno())
-        os.dup2(null, sys.stdout.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        if null > 2:
-            os.close(null)
-
-
-def killme(status = 0):
-    logger.debug("Stopping server with exit status %d", status)
-    exitstatus = status
-    if main_loop_started:
-        main_loop.quit()
-    else:
-        sys.exit(status)
-
-
-def main():
-    global exitstatus
-    exitstatus = 0
-    global main_loop_started
-    main_loop_started = False
-    
-    parser = OptionParser()
-    parser.add_option("-i", "--interface", type="string",
-                      default=None, metavar="IF",
-                      help="Bind to interface IF")
-    parser.add_option("-a", "--address", type="string", default=None,
-                      help="Address to listen for requests on")
-    parser.add_option("-p", "--port", type="int", default=None,
-                      help="Port number to receive requests on")
-    parser.add_option("--check", action="store_true", default=False,
-                      help="Run self-test")
-    parser.add_option("--debug", action="store_true", default=False,
-                      help="Debug mode")
-    parser.add_option("--priority", type="string",
-                      default="SECURE256",
-                      help="GnuTLS priority string"
-                      " (see GnuTLS documentation)")
-    parser.add_option("--servicename", type="string",
-                      default="Mandos", help="Zeroconf service name")
-    (options, args) = parser.parse_args()
-    
-    if options.check:
-        import doctest
-        doctest.testmod()
-        sys.exit()
-    
-    # Parse config file
-    defaults = { "timeout": "1h",
-                 "interval": "5m",
-                 "checker": "fping -q -- %%(fqdn)s",
-                 }
-    client_config = ConfigParser.SafeConfigParser(defaults)
-    #client_config.readfp(open("global.conf"), "global.conf")
-    client_config.read("mandos-clients.conf")
-    
-    global serviceName
-    serviceName = options.servicename;
-    
-    global main_loop
-    global bus
-    global server
-    # From the Avahi example code
-    DBusGMainLoop(set_as_default=True )
-    main_loop = gobject.MainLoop()
-    bus = dbus.SystemBus()
-    server = dbus.Interface(
-            bus.get_object( avahi.DBUS_NAME, avahi.DBUS_PATH_SERVER ),
-            avahi.DBUS_INTERFACE_SERVER )
-    # End of Avahi example code
-    
-    debug = options.debug
-    
-    if debug:
-        console = logging.StreamHandler()
-        # console.setLevel(logging.DEBUG)
-        console.setFormatter(logging.Formatter\
-                             ('%(levelname)s: %(message)s'))
-        logger.addHandler(console)
-        del console
-    
-    clients = Set()
-    def remove_from_clients(client):
-        clients.remove(client)
-        if not clients:
-            logger.debug(u"No clients left, exiting")
-            killme()
-    
-    clients.update(Set(Client(name=section,
-                              stop_hook = remove_from_clients,
-                              **(dict(client_config\
-                                      .items(section))))
-                       for section in client_config.sections()))
-    
-    if not debug:
-        daemon(False, False)
-    
-    def cleanup():
-        "Cleanup function; run on exit"
-        global group
-        # From the Avahi example code
-        if not group is None:
-            group.Free()
-            group = None
-        # End of Avahi example code
-        
-        while clients:
-            client = clients.pop()
-            client.stop_hook = None
-            client.stop()
-    
-    atexit.register(cleanup)
-    
-    if not debug:
-        signal.signal(signal.SIGINT, signal.SIG_IGN)
-    signal.signal(signal.SIGHUP, lambda signum, frame: killme())
-    signal.signal(signal.SIGTERM, lambda signum, frame: killme())
-    
-    for client in clients:
-        client.start()
-    
-    tcp_server = IPv6_TCPServer((options.address, options.port),
-                                tcp_handler,
-                                options=options,
-                                clients=clients)
-    # Find out what random port we got
-    global servicePort
-    servicePort = tcp_server.socket.getsockname()[1]
-    logger.debug(u"Now listening on port %d", servicePort)
-    
-    if options.interface is not None:
-        global serviceInterface
-        serviceInterface = if_nametoindex(options.interface)
-    
-    # From the Avahi example code
-    server.connect_to_signal("StateChanged", server_state_changed)
-    try:
-        server_state_changed(server.GetState())
-    except dbus.exceptions.DBusException, error:
-        logger.critical(u"DBusException: %s", error)
-        killme(1)
-    # End of Avahi example code
-    
-    gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
-                         lambda *args, **kwargs:
-                         tcp_server.handle_request(*args[2:],
-                                                   **kwargs) or True)
-    try:
-        logger.debug("Starting main loop")
-        main_loop_started = True
-        main_loop.run()
-    except KeyboardInterrupt:
-        if debug:
-            print
-    
-    sys.exit(exitstatus)
-
-if __name__ == '__main__':
-    main()

